#=====================================================================================================#
# -*- coding:Utf-8 -*-

# welcom_sound by DoC (16/12/2007)
# remerciemmment spéciale a NICOLOUS
# MATTIE'S EVENTSCRIPTS 2.0, PYTHON OPERATIONNEL

# PLUGIN = http://mattie.info/cs
# SCRIPT = http://addons.eventscripts.com/addons/view/welcom_sound
# analyseur de fichiers 'text' & 'config' = http://forums.mattie.info/cs/forums/viewtopic.php?t=18920

#=====================================================================================================#




#       MODULE      #


import es, os
from es import server_var
from FileAnalyse import FileAnalyse
from PlayMethode import PlayMethode


#       INFO        #


ws_info = es.AddonInfo()
ws_info.version = "1.1"
ws_info.author = "DoCky"
ws_info.name = "welcom_sound"
ws_info.tags = "français;music;sound;python"
ws_info.url = "http://addons.eventscripts.com/addons/user/11751"
ws_info.description = "play random sounds when a player reaches server"

es.ServerVar(ws_info.name, ws_info.version, "version actuelle du script").makepublic()
es.ServerVar("ws_play")
es.ServerVar("ws_down")
es.ServerVar("ws_logs")


#       SCRIPT      #


# Analyse et récupération de la liste de de lecture
ws_list = FileAnalyse(es.getAddonPath(ws_info.name).replace(os.sep,"/") + "/sound.cfg").getList()

# Initialisation du module de lecture
ws_play = PlayMethode(ws_list)


def load():
    # Exécution du block 'welcom_sound'
    welcom_sound()


def es_map_start(event_var):
    # Si la liste de sons évolue
    if len(ws_list) != len(FileAnalyse(es.getAddonPath(ws_info.name).replace(os.sep,"/") + "/sound.cfg").getList()):

        #  Réinitialisation du script
        es.reload(ws_info.name)

    # Sinon, éxécution du block 'welcom_sound'
    welcom_sound()


def welcom_sound():
    # Vérification de la présence des fichiers du script
    if WelcomSound().fileExist():

        # Exécution du fichier de configuration du script 'config.cfg'
        es.ForceServerCommand("es_mexec ../addons/eventscripts/welcom_sound/config.cfg")

        # Si le script est configuré pour le téléchargement
        if int(server_var["ws_down"]):

            # Execution du module de téléchargerment
            WelcomSound().fileDownload()


        # - Méthode : dans l'ordre
        if server_var["ws_play"] == "order":

            # Passer a la piste suivante
            ws_play.nextList()

        # - Méthode : dans le désordre
        elif server_var["ws_play"] == "shuffle":

            # Passer a la piste suivante
            ws_play.nextShuf()

        # - Méthode : aléaroire
        elif server_var["ws_play"] == "random":

            # Passer a la piste suivante
            ws_play.nextRand()


def player_activate(event_var):
    # Si le script est activé
    if str(server_var["ws_play"]) != "0":

        # Joue le sons sélectionné selon la méthode
        ws_play.soundPlay(event_var["userid"], 1)


#=====================================================================================================#



#  PIVATE CLASS: internal class associated to welcom_sound.py addon-script  #

class WelcomSound:
    """
        Classe privé. Conçerne uniquement le script welcom_sound

        - Vérifie la présence des fichiers du script
        - Téléchargement des sons de la liste
    """


    @staticmethod
    def fileExist():
        """
            Fonction: certifier la présence des fichiers nécessaire a la bonne éxécution du script 'welcom_sound.py'
        """


        # Variable local
        ws_path = es.getAddonPath(ws_info.name).replace(os.sep,"/") + "/"

        # Si le fichier 'config.cfg' n'est pas présent
        if not os.path.isfile(ws_path + "config.cfg"):

            # Log éventuel
            if int(server_var["ws_logs"]):
                es.log("[welcom_sound] fichier manquant: " + ws_path + "Config.cfg")

            # Renvoie 'False'
            return False

        # Si le fichier 'sound.cfg' n'est pas présent
        elif not os.path.isfile(ws_path + "sound.cfg"):

            # Log éventuel
            if int(server_var["ws_logs"]):
                es.log("[welcom_sound] fichier manquant: " + ws_path + "Sound.cf'")

            # Renvoie 'False'
            return False

        # Sinon, tout est en ordre
        else:

            # Renvoie 'True'
            return True


    @staticmethod
    def fileDownload():
        """
            Fonction: faire télécharger les fichiers sons de la liste aux joueurs
        """


        # Pour touts les éléments de la liste
        for ws_down in ws_list:

            # Ajouter à la base de données de téléchargement VALVE
            es.stringtable("downloadables", "sound/" + ws_down)
